package com.macro.mall.tiny.modules.business.controller;

import com.macro.mall.tiny.modules.business.service.FileService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

/**
 * 大文件上传
 */
@RestController
@RequestMapping("/file")
@CrossOrigin
@Api(tags = "文件上传相关接口", description = "提供文件上传相关API")
public class BigFileUploadController {
    @Autowired
    private FileService fileService;


    /**
     * @param size
     * @param chunks 文件分块数
     * @param chunk  文件分块序号
     * @param file   文件
     * @throws IOException
     */
    @ApiOperation("文件上传接口")
    @PostMapping("/upload")
    public void upload(Long size,
                       Integer chunks,
                       Integer chunk,
                       MultipartFile file) throws IOException {
        if (chunks != null && chunks != 0) {
            fileService.uploadWithBlock(size, chunks, chunk, file);
        } else {
            fileService.upload(file);
        }
    }
}
