package com.macro.mall.tiny.modules.business.service.impl;

import com.macro.mall.tiny.common.util.FileUtils;
import com.macro.mall.tiny.config.UploadConfig;
import com.macro.mall.tiny.modules.business.service.FileService;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;
import java.util.Date;

import static com.macro.mall.tiny.common.util.UploadUtils.*;


/**
 * 文件上传服务
 */
@Service
public class FileServiceImpl implements FileService {

    /**
     * 上传文件
     *
     * @param file
     */
    public void upload(MultipartFile file) throws IOException {
        String path = UploadConfig.path + file.getOriginalFilename();
        FileUtils.write(path, file.getInputStream());
    }

    /**
     * 分块上传文件
     *
     * @param size
     * @param chunks
     * @param chunk
     * @param file
     * @throws IOException
     */
    public void uploadWithBlock(Long size,
                                Integer chunks,
                                Integer chunk,
                                MultipartFile file) throws IOException {
        String fileName = file.getOriginalFilename();
        FileUtils.writeWithBlok(UploadConfig.tempPath + fileName, size, file.getInputStream(), file.getSize(), chunks, chunk);
        addChunk(fileName, chunk);
        if (isUploaded(fileName)) {
            removeKey(fileName);
        }
    }
}
